

jQuery('#classm8_admin').click(function(){
    jQuery('#classm8_admin_modal').modal('show');
});

jQuery(document).ready(function () {
    jQuery('#classm8_admin_modal').on('shown.bs.modal', function(){
	get_list_of_users();
    });
});

jQuery('#edit_server').click(function(){
    jQuery('#server_input').prop('disabled', false);
    jQuery(this).css('display','none');
    jQuery('#save_server').css('display','inline');
});

jQuery('#save_server').click(function(){
    jQuery.ajax({
	type: 'post',
	url: classm8_object.ajax_url,
	data: {action: 'save_server', server_name: jQuery('#server_input').val() },
	success: function(response){
	    if(response == "success"){
		//get_server_name_input();
		location.reload();
	    }
	    else{
		alert('error: '+ response + 'code: 2');
	    }
	},
	error: function(){
	    alert('Error, try again! code: 1');
	}
    });
});

jQuery('#edit_new_user').click(function(){
    jQuery('#new_user_email').prop('disabled', false);
    jQuery('#new_user_password').prop('disabled', false);
    jQuery('#new_user_type').prop('disabled', false);
    jQuery(this).css('display','none');
    jQuery('#save_new_user').css('display','inline');
});

jQuery('#save_new_user').click(function(){
	
	if(!validateEmail(jQuery('#new_user_email').val()) || !validatePassword(jQuery('#new_user_password').val()) ){
	    if(!validateEmail(jQuery('#new_user_email').val())){
		jQuery('#new_user_email').addClass('input_error');
	    }
	    if(!validatePassword(jQuery('#new_user_password').val())){
		jQuery('#new_user_password').addClass('input_error');
	    }

	    return;
	}


    jQuery.ajax({
	type: 'post',
	url: classm8_object.ajax_url,
	data: {	action: 'save_new_user',
		new_user_email: jQuery('#new_user_email').val(),
		password: jQuery('#new_user_password').val(),
		new_user_type: jQuery('#new_user_type').val(), 
		},
	success: function(response){
	    if(response == "success"){
		get_blank_new_user_input();
	    }
	    else{
		alert('error: '+ response + 'code: 5');
	    }
	},
	error: function(){
	    alert('Error, try again! code: 4');
	}

    });
});


jQuery('body').on( 'click', '.delete_classm8_user' , function(){
    jQuery.ajax({
	type: 'post',
	url: classm8_object.ajax_url,
	data: {	action: 'delete_classm8_user',
		user_email: jQuery(this).parent().find('.classm8_user_email').text(),
		},
	success: function(response){
	    if(response == "success"){
		get_list_of_users();
	    }
	    else{
		alert('error: '+ response + 'code: 8');
	    }
	},
	error: function(){
	    alert('Error, try again! code: 7');
	}

    });

});


jQuery('.reg_game_button').click(function(){
    var game_name = jQuery(this).closest('.card').find('.card-link').text();
    var game_id = jQuery(this).data('game_id');
    
    jQuery.ajax({
	type: 'post',
	url: classm8_object.ajax_url,
	data: { action: 'get_classm8_game_id',
		game_id: game_id,
		},
	success: function(response){
	    
	    jQuery('#classm8_game_data').html(response);
	    jQuery('#game_modal').find('.modal-title').text(game_name);
	    jQuery('#game_modal').modal('show');
	},
	error: function(){
	    alert('Error, try again! code: 10');
	}


    });
    

});

jQuery(document).ready(function () {
    jQuery('.card').on('show.bs.collapse', function(){
	jQuery(this).find('.edit_game_descripton').css('display','inline');
	
	var game_id = jQuery(this).find('.card-header').data('game_id');
	jQuery(this).find('.reg_game_button').css('display','inline');

	get_classm8_game_description(game_id, jQuery(this).find('.classm8_editor') );
    

    });
});

jQuery(document).ready(function () {
    jQuery('.card').on('hide.bs.collapse', function(){
	jQuery(this).find('.edit_game_descripton').css('display','none');
	jQuery(this).find('.save_game_descripton').css('display','none');

	var editor_id = jQuery(this).find('.classm8_editor').attr('id');
	wp.editor.remove(editor_id);
    });
});

jQuery('body').on('click', '.edit_game_descripton', function(event){
    event.stopPropagation();
    
    jQuery(this).css('display','none');
    jQuery(this).closest('.card').find('.save_game_descripton').css('display','inline');
    jQuery(this).closest('.card').find('.reg_game_button').css('display','none');


    var editor_id = jQuery(this).closest('.card').find('.classm8_editor').attr('id');

    wp.editor.initialize(
      editor_id,
      {
        tinymce: {
          wpautop: true,
          plugins : 'charmap colorpicker compat3x directionality fullscreen hr image lists media paste tabfocus textcolor wordpress wpautoresize wpdialogs wpeditimage wpemoji wpgallery wplink wptextpattern wpview',
          toolbar1: 'bold italic underline strikethrough | bullist numlist | blockquote hr wp_more | alignleft aligncenter alignright | link unlink | fullscreen | wp_adv',
          toolbar2: 'formatselect alignjustify forecolor | pastetext removeformat charmap | outdent indent | undo redo | wp_help'
        },
        quicktags: true,
        mediaButtons: false,
      }
    );

});


jQuery('body').on('click', '.save_game_descripton', function(){
    event.stopPropagation();

    jQuery(this).css('display','none');
    jQuery(this).closest('.card').find('.edit_game_descripton').css('display','inline');
    jQuery(this).closest('.card').find('.reg_game_button').css('display','inline');
    
    var editor_id = jQuery(this).closest('.card').find('.classm8_editor').attr('id');
    var game_id = jQuery(this).closest('.card-header').data('game_id');
    var description = tinyMCE.get(editor_id).getContent();
    //var description = '<b>vastag</b><i>ez meg dölt</i><script>alert("hellóka")</script>';

    jQuery.ajax({
	type: 'post',
	url: classm8_object.ajax_url,
	context: this,
	data: { action: 'save_classm8_game_description',
		game_id: game_id,
		description: description,
		},
	success: function(response){

	    //console.log(response);
	    get_classm8_game_description(game_id,jQuery(this).closest('.card').find('.classm8_editor') );
	    wp.editor.remove(editor_id);

	},
	error: function(){
	    alert('Error, try again! code: 11');
	}


    });


});

function get_classm8_game_description(game_id, that){
    

    jQuery.ajax({
	type: 'post',
	url: classm8_object.ajax_url,
	context: this,
	async: false,
	data: { action: 'get_classm8_game_description',
		game_id: game_id,
		},
	success: function(response){

	    that.html(response);

	},
	error: function(){
	    alert('Error, try again! code: 11');
	}

    });


}


function get_server_name_input(){
    jQuery.ajax({
	type: 'post',
	url: classm8_object.ajax_url,
	data: {action: 'get_server_name' },
	success: function(response){
	    jQuery('#edit_server').css('display','inline');
	    jQuery('#save_server').css('display','none');
	    jQuery('#server_input').val(response).prop('disabled', true);
	},
	error: function(){
	    alert('Error, try again! code: 3');
	}
    });
}

function get_blank_new_user_input(){
    jQuery('#new_user_email').prop('disabled', true);
    jQuery('#new_user_password').prop('disabled', true);
    jQuery('#new_user_type').prop('disabled', true);
    jQuery('#edit_new_user').css('display','inline');
    jQuery('#save_new_user').css('display','none');
    get_list_of_users();
}

function get_list_of_users(){
    jQuery.ajax({
	type: 'post',
	url: classm8_object.ajax_url,
	data: {action: 'get_classm8_users' },
	success: function(response){
	    try{
		var classm8_users_list = JSON.parse(response);
		var list_of_users_html = '';
		for(var user in classm8_users_list ){
	
		    var admin_icon = classm8_users_list[user].roles == 'classm8_admin' ? '<span style="font-size: 70%; margin-left: 1em;"><i class="fas fa-key"></i></span>' : '';
		    var html = '<div style="display: flex; justify-content: space-between; border-bottom: solid 1px #ccc; padding: 0.36rem 0.66rem; margin-top: 0.3em;">'
				+'<span>'
				+	'<span style="font-size: 70%;" class="classm8_user_email">'+classm8_users_list[user].user_email+'</span>'
				+ 	admin_icon
				+'</span>'
				+'<span class="delete_classm8_user" style="cursor: pointer;"><i class="far fa-trash-alt"></i></span>'
			     +'</div>';
		    list_of_users_html = list_of_users_html + html;
		}
		
		jQuery('#list_of_users').html(list_of_users_html);
	    }
	    catch(err){
		alert(response);
	    }
	},
	error: function(){
	    alert('Error, try again! code: 6');
	}
    });


}


function validateEmail(email) {
  var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
  return re.test(email);
}

function validatePassword(password) {
  var re = /^.{8,15}$/;
  return re.test(password);
}
