<?php
$user = wp_get_current_user();
$server = get_option('classm8_server');

//$server = 'https://play.norbi.classm8.org/';

function isJson($string) {
 json_decode($string);
 return (json_last_error() == JSON_ERROR_NONE);
}


get_header();
if ( ! is_user_logged_in() ) { // Display WordPress login form:
    $args = array(
        'redirect' => home_url(),
	'echo' => false,
        'form_id' => 'loginform-custom',
        'label_username' => __( '' ), //így írom, mert akkor nem kell elrejteni a label-t
        'label_password' => __( '' ), //így írom, mert akkor nem kell elrejteni a label-t
        'label_remember' => __( 'Jelszó megjegyzése' ),
        'label_log_in' => __( 'Belépés' ),
	'id_username' => "classm8_username_input",
	'id_password' => "classm8_password_input",
	'id_remember' => "classm8_remember_input",
	'id_submit' => "classm8_submit_login",
        'remember' => true
    );
    ?>
    <div >
    <h1 class="classm8_title" >
	<div>
	    <img src="<?php echo get_stylesheet_directory_uri();?>/logo.png" class="logo" style="width: 25vw;" />
	</div>
	<span style="color: #353c3f;">Classm8</span>
    </h1>
    <?php
    $form = wp_login_form( $args );
    $form = str_replace('name="log"', 'name="log" placeholder="e-mail"', $form); //így adom hozzá a placeholdert
    $form = str_replace('name="pwd"', 'name="pwd" placeholder="jelszó"', $form); //így adom hozzá a placeholdert
    
    echo '<div>'.$form.'</div></div>';

} else { // If logged in:
    ?>
    <div id="page_header" style="height: 4em; width: 100vw; display: flex;">
	<div style="width: 50vw; line-height: 80%; padding-top: 0.5em; padding-left: 1em; text-align: left;">
	    <a href="https://classm8.org" style="cursor: pointer;">
		<img src="<?php echo get_stylesheet_directory_uri();?>/logo.png" class="logo" style="max-height:60%;" />
		<br>
		<span style="color: #353c3f; font-size: 1em;" class="classm8_title">Classm8</span>
	    </a>
	</div>
	<div style="width: 50vw; padding-right: 1em; display:flex; justify-content: flex-end; align-items: center;">
	    <?php
		if(in_array($user -> roles[0] , array( 'administrator', 'classm8_admin'))){
		    ?>
	    	    <span id="classm8_admin" class="classm8_admin_icon" style="margin-right: 0.5em;"><i class="fas fa-cog"></i></span>
		    <?php
		}
	    ?>
	    <a href="<?php echo esc_url( wp_logout_url( home_url() )); ?> " class="classm8_admin_icon"><i class="fas fa-sign-out-alt"></i></a>
	</div>
	
	<?php
	if(in_array($user -> roles[0] , array( 'administrator', 'classm8_admin'))){
        ?>
	<!-- The Modal -->
	    <div class="modal" id="classm8_admin_modal">
		<div class="modal-dialog">
		    <div class="modal-content">

    		<!-- Modal Header -->
    			<div class="modal-header">
    			    <h4 class="modal-title">Beállítás</h4>
			    <button type="button" class="close" data-dismiss="modal">&times;</button>
    			</div>

    		<!-- Modal body -->
    			<div class="modal-body">
    			    <div id="server">
				<div>
				    <div class="form-group" style="text-align: left;">
					<label for="server_input" style="font-weight: bold; display:flex; justify-content: space-between;" >
					    <span>server:</span>
					    <span id="edit_server" style="cursor: pointer;"><i class="fas fa-edit"></i></span>
					    <span id="save_server" style="cursor: pointer; display: none;"><i class="far fa-save"></i></span>
					</label>
					<input 
					    type="text"
					    class="form-control"
					    id="server_input"
					    <?php
					    if($server){
						echo 'value="'.$server.'"';
					    }
					    ?>
					    disabled
					    placeholder="https://example.com"
					>
				    </div>
				</div>
			    </div>
			    <div id="add_new_user">
				<div>
				    <div class="form-group" style="text-align: left;">
					<label style="font-weight: bold; display:flex; justify-content: space-between;">
					    <span>új felhasználó:</span>
					    <span id="edit_new_user" style="cursor: pointer;"><i class="fas fa-edit"></i></span>
					    <span id="save_new_user" style="cursor: pointer; display: none;"><i class="far fa-save"></i></span>
					</label>
					<input type="text" class="form-control" id="new_user_email" placeholder="e-mail" disabled >
					<div style="display: flex; justify-content: space-between;">
					<input type="password" class="form-control" id="new_user_password" placeholder="jelszó (8-15 char)" style="margin-top: 0.3em; width: 65%;" disabled>
					<select class="form-control" id="new_user_type" style="width: 35%; margin-top: 0.3em; margin-left: 0.3em; border-radius: 0;" disabled>
					    <option>tanár</option>
					    <option>admin</option>
					</select>
					</div>
				    </div>
				</div>
			    </div>
			    <div id="all_users">
				<div style="text-align: left; font-weight: bold;">
				    <span>felhasználók:</span>
				</div>
				<div id="list_of_users"></div>
			    </div>
    			</div>

    		<!-- Modal footer -->
    			<div class="modal-footer">
    			    <button type="button" class="btn btn-danger" data-dismiss="modal">Mégse</button>
    			</div>

		    </div>
		</div>
	    </div>

	<!-- End of Modal -->
	<?php
	}
        ?>

    </div>
    <div>
	<?php
	    if($server){
		$json = file_get_contents($server.'/api/game_list');
		if(isJson($json)){
		    $json = json_decode($json , true);
		    
		    $all_html = '';

		    $edit_icon = in_array($user -> roles[0] , array( 'administrator', 'classm8_admin')) ? '<span class="edit_game_descripton" style="float: right; display: none; cursor: pointer;"><i class="fas fa-edit"></i></span>' : '';
		    $save_icon = in_array($user -> roles[0] , array( 'administrator', 'classm8_admin')) ? '<span class="save_game_descripton" style="float: right; display: none; cursor: pointer;"><i class="fas fa-save"></i></span>' : '';
		    
		    
		    foreach($json as $id => $game){
			if($game['id'] < 9 || $game['id'] >= 50 ) { continue;}
			$html =
			
			'<div class="card" style="margin-bottom: 1em;">'
			    .'<div class="card-header" data-toggle="collapse" href="#collapse_game_'.$game['id'].'" style="cursor: pointer;" data-game_id="'.$game['id'].'">'
    				.'<span class="card-link" >'
    				    .$game['title']
    				.'</span>'
				. $edit_icon
				. $save_icon
			    .'</div>'
			    .'<div id="collapse_game_'.$game['id'].'" class="collapse" data-parent="#accordion">'
    				.'<div class="card-body">'
				    .'<div class="classm8_game_description"></div>'
    				    .'<div class="classm8_editor" id="classm8_editor_'.$id.'">'
				    .'</div>'
    				.'</div>'
				.'<div style="padding-bottom: 1em;">'
				    .'<button type="button" class="btn btn-info reg_game_button" data-game_id="'.$game['id'].'">Játék regisztrálása</button>'
				.'</div>'
			    .'</div>'
			.'</div>';

			$all_html .= $html;
		    }

		    $game_modal =    '<!-- The Modal -->'
				    .'<div class="modal" id="game_modal">'
					.'<div class="modal-dialog">'
					    .'<div class="modal-content">'

    					    .'<!-- Modal Header -->'
    						.'<div class="modal-header">'
    						    .'<h4 class="modal-title">Modal Heading</h4>'
    						    .'<button type="button" class="close" data-dismiss="modal">&times;</button>'
    						.'</div>'

    					    .'<!-- Modal body -->'
    						.'<div class="modal-body">'
    						    .'<div>'
							.'<h3>Játékkód:</h3>'
							.'<div id="classm8_game_data"></div>'
						    .'</div>'

    						.'</div>'

    					    //.'<!-- Modal footer -->'
    						//.'<div class="modal-footer">'
    						    //.'<button type="button" class="btn btn-danger" data-dismiss="modal">mégse</button>'
    						//.'</div>'

					    .'</div>'
					.'</div>'
				    .'</div>';

		    echo  '<h1 style="line-height: 1;" id="home_page_title">Játékok</h1>'
			  . '<div style="display: flex; justify-content: center; width: 100vw;">'
			    .'<div id="accordion" style="width: 100%; max-width: 40em;">'.$all_html.'</div>'
			  .'</div>'
			  .$game_modal;
		}
		else{
		    echo "<h1>Server leállás, vagy hibás server beállítás.</h1>";
		}
	    }
	    else{
		echo "<h1>Hiányzó server beállítás.</h1>";
	    }
	?>
    </div>
    <?php
    

}
get_footer();
?>